diff --git a/src/common/resources/lang/en_US/item.lang b/src/common/resources/lang/en_US/item.lang
index dbe4c551b..5c68d7bfb 100644
--- a/src/common/resources/lang/en_US/item.lang
+++ b/src/common/resources/lang/en_US/item.lang
@@ -251,37 +251,37 @@ item.bone.desc=Spooky...
 item.dye.name=Dye
 item.dye.desc=How did you get this?!
 item.dye.black.name=Ink Sac
-item.dye.black.desc=Can be used to colour certain blocks black.
+item.dye.black.desc=Can be used to color certain blocks black.
 item.dye.red.name=Rose Red
-item.dye.red.desc=Can be used to colour certain blocks red.
+item.dye.red.desc=Can be used to color certain blocks red.
 item.dye.green.name=Cactus Green
-item.dye.green.desc=Can be used to colour certain blocks green.
+item.dye.green.desc=Can be used to color certain blocks green.
 item.dye.brown.name=Cocoa Beans
-item.dye.brown.desc=Smells like chocolate... Can also be used to colour certain blocks brown.
+item.dye.brown.desc=Smells like chocolate... Can also be used to color certain blocks brown.
 item.dye.blue.name=Lapis Lazuli
-item.dye.blue.desc=Can be used to colour certain blocks blue.
+item.dye.blue.desc=Can be used to color certain blocks blue.
 item.dye.purple.name=Purple Dye
-item.dye.purple.desc=Can be used to colour certain blocks purple.
+item.dye.purple.desc=Can be used to color certain blocks purple.
 item.dye.cyan.name=Cyan Dye
-item.dye.cyan.desc=Can be used to colour certain blocks cyan.
+item.dye.cyan.desc=Can be used to color certain blocks cyan.
 item.dye.silver.name=Light Gray Dye
-item.dye.silver.desc=Can be used to colour certain blocks light gray.
+item.dye.silver.desc=Can be used to color certain blocks light gray.
 item.dye.gray.name=Gray Dye
-item.dye.gray.desc=Can be used to colour certain blocks gray.
+item.dye.gray.desc=Can be used to color certain blocks gray.
 item.dye.pink.name=Pink Dye
-item.dye.pink.desc=Can be used to colour certain blocks pink.
+item.dye.pink.desc=Can be used to color certain blocks pink.
 item.dye.lime.name=Lime Dye
-item.dye.lime.desc=Can be used to colour certain blocks lime.
+item.dye.lime.desc=Can be used to color certain blocks lime.
 item.dye.yellow.name=Dandelion Yellow
-item.dye.yellow.desc=Can be used to colour certain blocks yellow.
+item.dye.yellow.desc=Can be used to color certain blocks yellow.
 item.dye.lightblue.name=Light Blue Dye
-item.dye.lightblue.desc=Can be used to colour certain blocks light blue.
+item.dye.lightblue.desc=Can be used to color certain blocks light blue.
 item.dye.magenta.name=Magenta Dye
-item.dye.magenta.desc=Can be used to colour certain blocks magenta.
+item.dye.magenta.desc=Can be used to color certain blocks magenta.
 item.dye.orange.name=Orange Dye
-item.dye.orange.desc=Can be used to colour certain blocks orange.
+item.dye.orange.desc=Can be used to color certain blocks orange.
 item.dye.white.name=Bone Meal
-item.dye.white.desc=A nourishing meal for plants. Can also be used to colour certain blocks white.
+item.dye.white.desc=A nourishing meal for plants. Can also be used to color certain blocks white.
 item.dust.sugar.name=Sugar
 item.dust.sugar.desc=Can craft sweet treats.
 item.food.cake.name=Cake
diff --git a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
index 48d9792e8..f1e10fa1b 100644
--- a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
+++ b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
@@ -495,7 +495,7 @@ public class BiomeFinder implements MinecraftAccessor {
 		} else {
 			SaveFormatBase saveFormat = new SaveFormat19134(worldFolder.getParentFile());
 			LevelStorage saveHandler = saveFormat.getSaveHandler(worldFolder.getName(), false);
-			world = new World(saveHandler, saveHandler.getLevelData().getWorldName(), saveHandler.getLevelData().getRandomSeed(), null, null, new SpawnerMobs.SpawnerConfig());
+			world = new World(saveHandler, saveHandler.getLevelData().getWorldName(), saveHandler.getLevelData().getRandomSeed(), null, null);
 			biomeProvider = worldType.createBiomeProvider(world);
 		}
 		allBiomes.clear();
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index efe8d6ff9..3841e2e43 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -2117,7 +2117,7 @@ public class Minecraft
                     }
                 }
             }
-            World world = new World(saveHandler, worldName, seed, null, null, new SpawnerMobs.SpawnerConfig());
+            World world = new World(saveHandler, worldName, seed, null, null);
             if(world.isNewWorld)
             {
                 statsCounter.add(StatList.createWorldStat, 1);
diff --git a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
index 7d2bb10e1..b61ffaf0b 100644
--- a/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/LocalPlayer.java
@@ -438,26 +438,26 @@ public class LocalPlayer extends Player
         return mc.statsCounter.readStat(stat);
     }
 
-    private boolean isBlockTranslucent(int i, int j, int k)
+    private boolean isBlockTranslucent(int x, int y, int z)
     {
-        return world.isBlockNormalCube(i, j, k);
+        return world.isBlockNormalCube(x, y, z);
     }
 
     @Override
-    protected boolean checkInTile(double d, double d1, double d2)
+    protected boolean checkInTile(double x, double y, double z)
     {
         if (noPhysics) return false;
-        int i = MathHelper.floor(d);
-        int j = MathHelper.floor(d1);
-        int k = MathHelper.floor(d2);
-        double d3 = d - (double)i;
-        double d4 = d2 - (double)k;
-        if(isBlockTranslucent(i, j, k) || (isBlockTranslucent(i, j + 1, k) && !isDwarf))
+        int blockX = MathHelper.floor(x);
+        int blockY = MathHelper.floor(y);
+        int blockZ = MathHelper.floor(z);
+        double d3 = x - (double)blockX;
+        double d4 = z - (double)blockZ;
+        if(isBlockTranslucent(blockX, blockY, blockZ) || (isBlockTranslucent(blockX, blockY + 1, blockZ) && !isDwarf))
         {
-            boolean flag = !isBlockTranslucent(i - 1, j, k) && !isBlockTranslucent(i - 1, j + 1, k);
-            boolean flag1 = !isBlockTranslucent(i + 1, j, k) && !isBlockTranslucent(i + 1, j + 1, k);
-            boolean flag2 = !isBlockTranslucent(i, j, k - 1) && !isBlockTranslucent(i, j + 1, k - 1);
-            boolean flag3 = !isBlockTranslucent(i, j, k + 1) && !isBlockTranslucent(i, j + 1, k + 1);
+            boolean flag = !isBlockTranslucent(blockX - 1, blockY, blockZ) && !isBlockTranslucent(blockX - 1, blockY + 1, blockZ);
+            boolean flag1 = !isBlockTranslucent(blockX + 1, blockY, blockZ) && !isBlockTranslucent(blockX + 1, blockY + 1, blockZ);
+            boolean flag2 = !isBlockTranslucent(blockX, blockY, blockZ - 1) && !isBlockTranslucent(blockX, blockY + 1, blockZ - 1);
+            boolean flag3 = !isBlockTranslucent(blockX, blockY, blockZ + 1) && !isBlockTranslucent(blockX, blockY + 1, blockZ + 1);
             byte byte0 = -1;
             double d5 = 9999D;
             if(flag && d3 < d5)
diff --git a/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java b/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
index fb58f2013..e9152027a 100644
--- a/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
+++ b/src/main/java/net/minecraft/client/entity/player/MultiplayerLocalPlayer.java
@@ -8,7 +8,7 @@ import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.net.packet.ChatPacket;
-import net.minecraft.core.net.packet.PlayerCommandPacket;
+import net.minecraft.core.net.packet.UpdatePlayerStatePacket;
 import net.minecraft.core.net.packet.MovePlayerPacket;
 import net.minecraft.core.net.packet.ContainerClosePacket;
 import net.minecraft.core.net.packet.UpdateCreativeInventoryPacket;
@@ -87,10 +87,10 @@ public class MultiplayerLocalPlayer extends LocalPlayer
         {
             if(flag)
             {
-                sendQueue.addToSendQueue(new PlayerCommandPacket(this, 1));
+                sendQueue.addToSendQueue(new UpdatePlayerStatePacket(UpdatePlayerStatePacket.STATE_SNEAK));
             } else
             {
-                sendQueue.addToSendQueue(new PlayerCommandPacket(this, 2));
+                sendQueue.addToSendQueue(new UpdatePlayerStatePacket(UpdatePlayerStatePacket.STATE_UN_SNEAK));
             }
             wasSneaking = flag;
         }
@@ -106,21 +106,21 @@ public class MultiplayerLocalPlayer extends LocalPlayer
         {
             if(flag2)
             {
-                sendQueue.addToSendQueue(new MovePlayerPacket.Pos(xd, -999D, -999D, zd, onGround));
+                sendQueue.addToSendQueue(new MovePlayerPacket.Pos(xd, -999D, zd, onGround));
             } else
             {
-                sendQueue.addToSendQueue(new MovePlayerPacket.PosRot(xd, -999D, -999D, zd, yRot, xRot, onGround));
+                sendQueue.addToSendQueue(new MovePlayerPacket.PosRot(xd, -999D, zd, yRot, xRot, onGround));
             }
             flag1 = false;
         } else
         if(flag1 && flag2)
         {
-            sendQueue.addToSendQueue(new MovePlayerPacket.PosRot(x, bb.minY, y, z, yRot, xRot, onGround));
+            sendQueue.addToSendQueue(new MovePlayerPacket.PosRot(x, bb.minY, z, yRot, xRot, onGround));
             noSendTime = 0;
         } else
         if(flag1)
         {
-            sendQueue.addToSendQueue(new MovePlayerPacket.Pos(x, bb.minY, y, z, onGround));
+            sendQueue.addToSendQueue(new MovePlayerPacket.Pos(x, bb.minY, z, onGround));
             noSendTime = 0;
         } else
         if(flag2)
@@ -155,7 +155,7 @@ public class MultiplayerLocalPlayer extends LocalPlayer
 
     @Override
     public void dropCurrentItem(boolean dropFullStack) {
-        sendQueue.addToSendQueue(new PlayerActionPacket(dropFullStack ? 5 : 4, 0, 0, 0, Side.NONE, 0.0, 0.0));
+        sendQueue.addToSendQueue(new PlayerActionPacket(dropFullStack ? PlayerActionPacket.ACTION_DROP_ITEM_STACK : PlayerActionPacket.ACTION_DROP_ITEM_SINGLE, 0, 0, 0, Side.NONE, 0.0, 0.0));
     }
 
     private void sendInventoryChanged()
@@ -272,6 +272,6 @@ public class MultiplayerLocalPlayer extends LocalPlayer
     
     @Override
     public void pickBlock(int x, int y, int z) {
-    	sendQueue.addToSendQueue(new PlayerActionPacket(6, x, y, z, Side.NONE, 0.0, 0.0));
+    	sendQueue.addToSendQueue(new PlayerActionPacket(PlayerActionPacket.ACTION_PICK_BLOCK, x, y, z, Side.NONE, 0.0, 0.0));
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/ButtonElement.java b/src/main/java/net/minecraft/client/gui/ButtonElement.java
index 0230f3e2c..5093cec2a 100644
--- a/src/main/java/net/minecraft/client/gui/ButtonElement.java
+++ b/src/main/java/net/minecraft/client/gui/ButtonElement.java
@@ -3,6 +3,7 @@ package net.minecraft.client.gui;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
@@ -22,9 +23,9 @@ public class ButtonElement extends Gui implements GuiElement
     public int xPosition;
     public int yPosition;
     public String displayString;
-    public IconCoordinate defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button");
-    public IconCoordinate hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button_highlighted");
-    public IconCoordinate disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button_disabled");
+    public IconCoordinate defaultTexture;
+    public IconCoordinate hoveredTexture;
+    public IconCoordinate disabledTexture;
     public int id;
     public boolean enabled;
     public boolean visible;
@@ -46,12 +47,25 @@ public class ButtonElement extends Gui implements GuiElement
         this.width = width;
         this.height = height;
         displayString = text;
+        setDefaultTextures();
     }
 
-    public ButtonElement setTextures(String defaultTexture, String hoveredTexture, String disabledTexture) {
-        this.defaultTexture = TextureRegistry.getTexture(defaultTexture);
-        this.hoveredTexture = TextureRegistry.getTexture(hoveredTexture);
-        this.disabledTexture = TextureRegistry.getTexture(disabledTexture);
+    protected void setDefaultTextures() {
+        defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button/button");
+        hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button/button_highlighted");
+        disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button/button_disabled");
+    }
+
+    public ButtonElement setTextures(@Nullable String defaultTexture, @Nullable String hoveredTexture, @Nullable String disabledTexture) {
+        if (defaultTexture != null) {
+            this.defaultTexture = TextureRegistry.getTexture(defaultTexture);
+        }
+        if (hoveredTexture != null) {
+            this.hoveredTexture = TextureRegistry.getTexture(hoveredTexture);
+        }
+        if (disabledTexture != null) {
+            this.disabledTexture = TextureRegistry.getTexture(disabledTexture);
+        }
         return this;
     }
 
